"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = __importStar(require("path"));
const fs_1 = __importDefault(require("fs"));
function loadQueryFile(file) {
    var appDir;
    if (require.main)
        appDir = path.dirname(require.main.filename);
    else
        appDir = "./";
    const fullPath = path.join(appDir, "testHelpers", file);
    return fs_1.default.readFileSync(fullPath, "utf-8");
}
function up(conn) {
    return __awaiter(this, void 0, void 0, function* () {
        const create = loadQueryFile("create.sql");
        yield conn.query(create);
    });
}
exports.up = up;
function reset(conn) {
    return __awaiter(this, void 0, void 0, function* () {
        const truncate = loadQueryFile("truncate.sql");
        yield conn.query(truncate);
    });
}
exports.reset = reset;
